# Contributing to FLORIS

FLORIS is a community model, and we are excited for community contributions!
There are a variety of ways in which you can contribute beyond writing code.
This document provides a high-level overview of how you can get involved.


## Asking Questions

Have a question? Rather than opening an issue directly, please ask questions
or post comments in [Q&A Discussions](https://github.com/NREL/floris/discussions/categories/q-a).
The NREL team or other members of the community will assist. Your well-worded
question will serve as a resource to others searching for help.


## Providing Feedback

Your comments and feedback are very welcome. Please post to
[General Discussions](https://github.com/NREL/floris/discussions/categories/general)
with lots of information and detail. It is beneficial to consider
how someone else will understand your comments in order to make
them most effective.


## Reporting Issues

Have you identified a reproducible problem in FLORIS?
Have a feature request? We want to hear about it! Here's how you can make
reporting your issue as effective as possible.

### Look For an Existing Issue

Before you create a new issue, please do a search in
[open issues](https://github.com/microsoft/vscode/issues) to see if
the issue or feature request has already been filed.

If you find your issue already exists, make relevant comments and add your
[reaction](https://github.com/blog/2119-add-reactions-to-pull-requests-issues-and-comments).
Use a reaction in place of a "+1" comment:

- 👍 - upvote
- 👎 - downvote

If you cannot find an existing issue that describes your bug or feature,
create a new issue using the guidelines below.

### Writing Good Bug Reports and Feature Requests

File a single issue per problem and feature request. Do not enumerate
multiple bugs or feature requests in the same issue.

Do not add your issue as a comment to an existing issue unless it's for the
identical input. Many issues look similar, but have different causes.

The more information you can provide, the more likely someone will
be successful at reproducing the issue and finding a fix.

Please follow the issue template guidelines to include relevant information
that will help in diagnosing the problem.

### Final Checklist

Please remember to do the following:

- [ ] Search the issue repository to ensure your report is a new issue

- [ ] Recreate the issue with a minimally descriptive example

- [ ] Simplify your code around the issue to better isolate the problem


## Contributing Fixes

If you are interested in writing code to fix an issue or
submit a new feature, let us know in
[Ideas Discussions](https://github.com/NREL/floris/discussions/categories/ideas)!

We rely heavily on git and GitHub, so be sure to review the
contributing guidelines in the
[online documentation](https://floris.readthedocs.io/en/main/source/developers.html).
